import { CmsModel, HeadlessCms } from "@webiny/api-headless-cms/types";
import { Security } from "@webiny/api-security/types";
import { File, FileManagerAliasesStorageOperations, FileManagerFilesStorageOperations, FileManagerFilesStorageOperationsCreateBatchParams, FileManagerFilesStorageOperationsCreateParams, FileManagerFilesStorageOperationsDeleteParams, FileManagerFilesStorageOperationsGetParams, FileManagerFilesStorageOperationsListParams, FileManagerFilesStorageOperationsListResponse, FileManagerFilesStorageOperationsTagsParams, FileManagerFilesStorageOperationsTagsResponse, FileManagerFilesStorageOperationsUpdateParams } from "../types";
export declare class CmsFilesStorage implements FileManagerFilesStorageOperations {
    private readonly cms;
    private readonly security;
    private readonly model;
    private readonly aliases;
    private readonly filesWhereProcessor;
    private readonly tagsWhereProcessor;
    static create(params: {
        fileModel: CmsModel;
        cms: HeadlessCms;
        security: Security;
        aliases: FileManagerAliasesStorageOperations;
    }): Promise<CmsFilesStorage>;
    private constructor();
    private modelWithContext;
    create({ file }: FileManagerFilesStorageOperationsCreateParams): Promise<File>;
    createBatch({ files }: FileManagerFilesStorageOperationsCreateBatchParams): Promise<File[]>;
    delete({ file }: FileManagerFilesStorageOperationsDeleteParams): Promise<void>;
    get({ where }: FileManagerFilesStorageOperationsGetParams): Promise<File | null>;
    list(params: FileManagerFilesStorageOperationsListParams): Promise<FileManagerFilesStorageOperationsListResponse>;
    tags(params: FileManagerFilesStorageOperationsTagsParams): Promise<FileManagerFilesStorageOperationsTagsResponse[]>;
    update({ file }: FileManagerFilesStorageOperationsUpdateParams): Promise<File>;
    private getFileFieldValues;
}
